#include "Messages.h"

extern data data;
extern Audio sound;
extern Entity player;
extern Entity red_enemy;
//these bottom 4 are used in Game_Over() for re-setting the level
extern Entity purple_enemy;
extern Entity blue_enemy;
extern Entity yellow_enemy;
extern int start_time; 

//we need the time for Next_Level
extern int time_passed;

Messages::Messages(){}

Messages::~Messages()
{
	SDL_FreeSurface(bonus);
	SDL_FreeSurface(play);
	SDL_FreeSurface(play2);
	SDL_FreeSurface(introbg);
	
	if(introbgleft != NULL)
		SDL_FreeSurface(introbgleft);
	
	if(introbgright != NULL)
		SDL_FreeSurface(introbgright);

	if(introbgpushed != NULL)
		SDL_FreeSurface(introbgpushed);
	
	
	SDL_FreeSurface(controls1);
	SDL_FreeSurface(controls2);
	SDL_FreeSurface(beatboard);
	SDL_FreeSurface(options);
	SDL_FreeSurface(cont1);
	SDL_FreeSurface(cont2);

	//destroy text surface
	SDL_FreeSurface(text);

	//close the font
	TTF_CloseFont(font);
	TTF_CloseFont(font_big);

	//quit SDL_ttf
	TTF_Quit();
}




void Messages::Init()
{
	
	//load in the "bonus" image	  
	bonus = Load_Image("images/bonus.bmp");
	play = Load_Image("images/play.png");
	play2 = Load_Image("images/play2.png");
	controls1 = Load_Image("images/controls1.png");
	controls2 = Load_Image("images/controls2.png");
	introbg = Load_Image("images/introbg.png");
	introbgleft = Load_Image("images/introbgleft.png");
	introbgright = Load_Image("images/introbgright.png");
	introbgpushed = Load_Image("images/introbgpushed.png");
	beatboard = Load_Image("images/beatboard.png");

	options = Load_Image("images/options.png");

	cont1 = Load_Image("images/continue1.png");
	cont2 = Load_Image("images/continue2.png");	
	

	SDL_SetColorKey(bonus, SDL_SRCCOLORKEY,SDL_MapRGB(bonus->format, 255, 0, 255));
    
	SDL_SetColorKey(play, SDL_SRCCOLORKEY,SDL_MapRGB(play->format, 255, 0, 255));
    SDL_SetColorKey(play2, SDL_SRCCOLORKEY,SDL_MapRGB(play2->format, 255, 0, 255));
	
	
	SDL_SetColorKey(controls1, SDL_SRCCOLORKEY,SDL_MapRGB(controls1->format, 255, 0, 255));
    SDL_SetColorKey(controls2, SDL_SRCCOLORKEY,SDL_MapRGB(controls2->format, 255, 0, 255));

	SDL_SetColorKey(cont1, SDL_SRCCOLORKEY,SDL_MapRGB(cont1->format, 255, 0, 255));
    SDL_SetColorKey(cont2, SDL_SRCCOLORKEY,SDL_MapRGB(cont2->format, 255, 0, 255));
 
	//quit = false;
	drawing_message = false;

	// the w and h of the controls and play buttons
	button_w = 150;
	button_h = 50;

	//initialize SDL_ttf
	TTF_Init();

	//open font
	font = TTF_OpenFont("actionj.ttf",25);

	font_big = TTF_OpenFont("indigo.ttf",50);

	text = NULL; //init our text surface to NULL because we constantly free/allocate this each frame
}
void Messages::Update_Message()
{
	//if we are currently drawing a message
	if (drawing_message)
	{
	
		switch(current_message)
		{
		
			case BONUS:
				 DrawIMG(bonus,250,250); 
				 break;
		}

		update_counter--;   //decrease timeout by one, effectively doing a count-down untill the message is no longer drawn
	

		if (update_counter <= 0) //if we reached 0, its time to state change       
		{
			drawing_message = false;  //flip state changing to off
		}
	}//end if drawing messages

}

void Messages::Set_Message(Message MESSAGE, int TIME)
{
	drawing_message = true;  //flip state changing to on so it will update inside Update_Message
	update_counter = TIME;     
	current_message = MESSAGE;    
}

void Messages::Show_Intro()
{

	sound.Play(MUS_INTRO);	//play the intro music
			
	player.Set_xPos(50);
	player.Set_yPos(550);
	player.Set_Dir(GO_RIGHT);

	red_enemy.Set_xPos(0);
	red_enemy.Set_yPos(550);
	red_enemy.Set_Dir(GO_RIGHT);

    int tempx;
	int tempy;

	bool start = false;
	bool go_options = false; //do we go to options mode? (when the player clicks controls this goes to true)

	bool open1 = true;
	bool open2 = true;
	bool stretch = true;
  
	while(!start)
	{

		SDL_Event event; //create an event holder

		  while ( SDL_PollEvent(&event) ) //looks for events
		 {
	  
			  if ( event.type == SDL_QUIT )  
			  {  
				  //quit = true; 
				  start = true;
				  data.done = 1;
				  //data.done = 1;
				 
			  } //if the user pressed the X on the screeen quit

			  if ( event.type == SDL_KEYDOWN ) //if the user pressed a key then.....
				{
					 if ( event.key.keysym.sym == SDLK_ESCAPE || event.key.keysym.sym == SDLK_q ) 
					 { 
					  start = true; //if they pressed escape or q then quit
					  data.done = 1;					
					 } 
		
				  }//end of    if ( event.type == SDL_KEYDOWN ) 
   
		 }//end of   while ( SDL_PollEvent(&event) ) 
    

		 //////////////////////////////////////////////////
		 // END OF TAKING INPUT

	
   
		SDL_GetMouseState(&tempx, &tempy);    // Get the mouse coords

		//the users mouse went to the bottom left corner of the screen
 		if(tempx < 300 && tempy > 400)
		{
		
			DrawBG(introbgleft,player.Get_xPos(),player.Get_yPos(),32,32);
		    DrawBG(introbgleft,red_enemy.Get_xPos(),red_enemy.Get_yPos(),32,32);

			
			
			 if(open1)
			{
				sound.Play(PAGE);
				open1 = false;
			}
			
			DrawIMG(introbgleft,0,0);
			//draw the "un-folded" left side BG
		//	DrawIMG(title,100,50);
			
			//if the users mouse is over the play button...
			if( (tempx > 10 && tempx < 10 + button_w) && (tempy > 525 && tempy < 525 + button_h) )
			{

				//draw the hover-ed version of play
				DrawIMG(play2,10,525);
				
				//if they left click....
				if(SDL_GetMouseState(NULL, NULL)&SDL_BUTTON(1))
				{
					sound.Play(BUTTON_PUSH);
					//start the game!
					start = true;
			
				}
			} //else its not over the play button, so draw the non-hovered version of 'play'
				else DrawIMG(play,10,525); 

		}

		//else if the user's mouse is on the bottom right corner of the screen....
		else if(tempx > 300 && tempy > 400)
		{

			DrawBG(introbgright,player.Get_xPos(),player.Get_yPos(),32,32);
		    DrawBG(introbgright,red_enemy.Get_xPos(),red_enemy.Get_yPos(),32,32);
			
			if(open2)
			{
			sound.Play(PAGE);
			open2 = false;
			}
			
			DrawIMG(introbgright,0,0);
			//draw the "un-folded" right side BG
		//	DrawIMG(title,100,50);
			
			//if the users mouse is over the play button...
			if( (tempx > 620 && tempx < 620 + button_w) && (tempy > 525 && tempy < 525 + button_h) )
			{

				//draw the hover-ed version of controls
				DrawIMG(controls2,620,525);
				
				//if they left click....
				if(SDL_GetMouseState(NULL, NULL)&SDL_BUTTON(1))
				{
					sound.Play(BUTTON_PUSH);
					//start the game!
					start = true;
					go_options = true;
					
				}
			     //else its not over the controls button, so draw the non-hovered version of 'play'
			}
				else DrawIMG(controls1,620,525); 

		}
		else
		{
			if(SDL_GetMouseState(NULL, NULL)&SDL_BUTTON(1))
			{
				if(stretch)
				{
					sound.Play(STRETCH);
					stretch = false;
				}

				DrawIMG(introbgpushed,0,0);
			//	DrawIMG(title,100,50);
				DrawBG(introbgpushed,player.Get_xPos(),player.Get_yPos(),32,32);
			    DrawBG(introbgpushed,red_enemy.Get_xPos(),red_enemy.Get_yPos(),32,32);
				
				DrawIMG(play2,10,525);
				DrawIMG(controls2,620,525);
			}
			else //else the user isnt clicking on anything... so draw everything as normal
			{
			
			open1 = true;
			open2 = true;
			stretch = true;

			DrawIMG(introbg,0,0);
		//	DrawIMG(title,100,50);
			DrawBG(introbg,player.Get_xPos(),player.Get_yPos(),32,32);
		    DrawBG(introbg,red_enemy.Get_xPos(),red_enemy.Get_yPos(),32,32);	
			
			}
		}
		
	
		if(player.Get_xPos() > 800)
		{
		
			player.Set_xPos(0);

			static int counter = 0;
			
			if(counter == 0)
			{
				player.Set_yPos(500);
				counter++;
			}
			else if (counter == 1)
			{
				player.Set_yPos(400);
				counter++;
			}
			else if (counter == 2)
			{
				player.Set_yPos(350);
				counter = 0;
			}

		}

		if(red_enemy.Get_xPos() > 800)
		{

			red_enemy.Set_xPos(0);

			
			static int counter2 = 0;
			
			if(counter2 == 0)
			{
				red_enemy.Set_yPos(500);
				counter2++;
			}
			else if (counter2 == 1)
			{
				red_enemy.Set_yPos(400);
				counter2++;
			}
			else if (counter2 == 2)
			{
				red_enemy.Set_yPos(350);
				counter2 = 0;
			}
		

		}//end if the enemy reached edge of screen

		player.Move_Right();
		red_enemy.Move_Right();
		
		player.Draw();
		red_enemy.Draw();

		SDL_Flip(data.screen);
	
	}

	if(go_options)
	{
		Options();
	}
       //stop the music on our way out....
	  
	//if we got here, this is the last time we are going to use these images, so free them
	//then make them = NULL
	SDL_FreeSurface(introbgleft);
	SDL_FreeSurface(introbgright);
	SDL_FreeSurface(introbgpushed);

	introbgleft = NULL;
	introbgright = NULL;
	introbgpushed = NULL;
	
	sound.Stop_Music(); 

}

void Messages::Next_Level()
{
	//stop the currently playing music and play the "you win" sound effect
	sound.Stop_Music();
	sound.Play(YOUWIN);
	
	//for managing the Next_Level sequence
	int start_time = SDL_GetTicks();
	bool next = false;

	//counters that start at 0 and count up towards the final number, and are drawn each frame
	int time_counter = 0;
	int score_counter = 0;
	int final_counter = 0;

	int one_time = 0; //this is so it draws "you beat level"  "!" only one time in the begining

	//calculate time_penalty. its just the number of seconds played * 3
	//time_penalty = (minutes * 60) * 5;
	//time_penalty =  time_penalty + (seconds * 5);

	int your_score = player.score;

	int time_penalty = time_passed * 5;

	//calc the final score
	int final_score = your_score - time_penalty;

	//draw our whole BG once... after this we slice it
	DrawIMG(beatboard,0,0);
			
	player.Set_xPos(50);
	player.Set_yPos(120);
	player.Set_Dir(GO_RIGHT);

	red_enemy.Set_xPos(0);
	red_enemy.Set_yPos(120);
	red_enemy.Set_Dir(GO_RIGHT);
		

	while(!next)
	{

		SDL_Event event; //create an event holder

		  while ( SDL_PollEvent(&event) ) //looks for events
		 {
	  
			  if ( event.type == SDL_QUIT )  
			  {  
				  next = true;
				  data.done = 1;
			  } 

			  if ( event.type == SDL_KEYDOWN ) //if the user pressed a key then.....
			  {
				     if ( event.key.keysym.sym == SDLK_ESCAPE || event.key.keysym.sym == SDLK_q ) 
					 { 
						 next = true;
						 data.done = 1; //if they pressed escape or q then quit
					 } 
		
			   }//end of    if ( event.type == SDL_KEYDOWN ) 
   
		 }//end of   while ( SDL_PollEvent(&event) ) 
    


		//draw the BG over the old player and enemy images
		DrawBG(beatboard,player.Get_xPos(),player.Get_yPos(),32,32);
		DrawBG(beatboard,red_enemy.Get_xPos(),red_enemy.Get_yPos(),32,32);

		//draw the BG over the old scores
		//first Your Score is at 450,200
		DrawBG(beatboard,450,200,200,100);
		//next Time Penalty is at 500,330
		DrawBG(beatboard,500,330,200,100);
		//last is Final Score at 450 460
		DrawBG(beatboard,450,460,200,100);
		 

		if(player.Get_xPos() > 800)
			player.Set_xPos(0);

		if(red_enemy.Get_xPos() > 800)
			red_enemy.Set_xPos(0);

		player.Move_Right();
		red_enemy.Move_Right();
		
		player.Draw();
		red_enemy.Draw();

		
		//first we draw all the non changing text one time

    	if(one_time == 0)
		{   


		char current_level[2];
		stringstream ss0;	
		ss0 << data.current_level;
		strcpy(current_level, ss0.str().c_str());

		
		Draw_Txt("You Beat Level",100,20,BIG,LIGHT);
		Draw_Txt(current_level,600,20,BIG,LIGHT);
		Draw_Txt("!",650,20,BIG,LIGHT);

		Draw_Txt("Your Score :",50,200,BIG,LIGHT);
		Draw_Txt("Time Penalty :",50,330,BIG,LIGHT); 
		Draw_Txt("Final Score :",50,460,BIG,LIGHT);

		one_time++;
		}

			  
       //now do the counter between 0 through player.score
		if(score_counter < your_score)
		{
			//increment score by 10
			score_counter += 10;
			//if we went past the score (this could happen because we are incrementing in invervals
			//of 10) then make the counter = the score
			if(score_counter > your_score)
				score_counter = your_score;

		}
	
		//start a string stream and convert score_counter into a string
		char points2[10];
		stringstream ss;	
		ss << score_counter;
		strcpy(points2, ss.str().c_str());

		Draw_Txt(points2,450,200,BIG,LIGHT);


		
		//time_counter starts at 0 in the begining before the loop starts
		//time penalty is found by calculating seconds played * 5
		if(time_counter < time_penalty)
			time_counter+=2; //we dont care if we go over 1 point here
	
		char time2[10];
		stringstream ss2;	
		ss2 << time_counter;
		strcpy(time2, ss2.str().c_str());

		//draw it now
		Draw_Txt(time2,500,330,BIG,LIGHT); 
 
		//lastly we want to draw "Final Score:" fs
		
		//now do the counter from 0 to final score and draw this counter
		
		if(final_counter < final_score)
		{
			final_counter+=10;

			if(final_counter > final_score)
				final_counter = final_score;

		}
		
		char final[10];
	
		//start a string stream and convert final score into a string
		stringstream ss3;	
		ss3 << final_counter;
		strcpy(final, ss3.str().c_str());

		Draw_Txt(final,450,460,BIG,LIGHT);
		
		//if 15 seconds have passed then this screen is over
		if((SDL_GetTicks() - start_time)/1000 >=15)
			next = true;

		SDL_Flip(data.screen);
	
	}//END OF WHILE !NEXT

}

void Messages::Draw_Txt(char* message,int x,int y,Message SIZE,Message COLOR)
{
	//chose the color based on what color we sent
	SDL_Color color;
	
	if(COLOR == LIGHT)
	{
		color.r = 255;
		color.g = 255;
		color.b = 255;
	}
	else if(COLOR == BLUE)
	{
		color.r = 0;
		color.g = 0;
		color.b = 255;
	}
	else if(COLOR == BLACK)
	{
		color.r = 0;
		color.g = 0;
		color.b = 0;
	}
	else if(COLOR == RED)
	{
		color.r = 255;
		color.g = 0;
		color.b = 0;
	}
	
	//first make it NULL if it isnt already...
	if(text != NULL)
	{
		SDL_FreeSurface(text);
		text = NULL;
	}

	//this if statement is just for safety, but it should be null at this point
	if(text == NULL)
	{
		//now reder our text based on what size we choose
		if(SIZE == SMALL)
			text = TTF_RenderText_Solid(font,message,color);
		else text = TTF_RenderText_Solid(font_big,message,color);
	}

	//rectangles
	SDL_Rect rcSrc;
	SDL_Rect rcDst;

	//source rectangle
	rcSrc.x = rcSrc.y = 0;
	rcSrc.w = text->w;
	rcSrc.h = text->h;

	//destination rectangle
	rcDst = rcSrc;
	rcDst.x = x;
	rcDst.y = y;

	//blit the text surface
	
	SDL_BlitSurface(text,&rcSrc,data.screen,&rcDst);

}

void Messages::Pause()
{

	bool resume = false;
		
	while(!resume)
	{

		SDL_Event event;				//create an event holder

		  while ( SDL_PollEvent(&event) ) //looks for events
		 {
	  
			  if ( event.type == SDL_QUIT )  
			  {  
				  resume = true;
				  data.done = 1;
			  } 

			  if ( event.type == SDL_KEYDOWN ) //if the user pressed a key then.....
			  {
				     if ( event.key.keysym.sym == SDLK_ESCAPE || event.key.keysym.sym == SDLK_q ) 
					 { 
						 resume = true;
						 data.done = 1; //if they pressed escape or q then quit
					 } 

					 if(event.key.keysym.sym == SDLK_p)
						 resume = true;
		
			   }//end of    if ( event.type == SDL_KEYDOWN ) 
   
		 }//end of   while ( SDL_PollEvent(&event) ) 

		 //draw PAUSED in big text in the middle of the screen
		 Draw_Txt("PAUSED",310,250,BIG,LIGHT);

		 SDL_Flip(data.screen);

	}//end of while ! resume

}//end of Pause()

void Messages::Options()
{

	int once = 0;
	bool start = false;
		
	int tempx;
	int tempy;

	while(!start)
	{

		SDL_Event event;				//create an event holder

		  while ( SDL_PollEvent(&event) ) //looks for events
		 {
	  
			  if ( event.type == SDL_QUIT )  
			  {  
				  start = true;
				  data.done = 1;
			  } 

			  if ( event.type == SDL_KEYDOWN ) //if the user pressed a key then.....
			  {
				     if ( event.key.keysym.sym == SDLK_ESCAPE || event.key.keysym.sym == SDLK_q ) 
					 { 
						 start = true;
						 data.done = 1; //if they pressed escape or q then quit
					 } 
		
			   }//end of    if ( event.type == SDL_KEYDOWN ) 
   
		 }//end of   while ( SDL_PollEvent(&event) ) 

		 //draw the options screen once
		 if(once == 0)
		 {
			 DrawIMG(options,0,0); //draw the options screen one time
			 once++;
		 }

		 
		SDL_GetMouseState(&tempx, &tempy);    // Get the mouse coords

		 		//if the users mouse is over the play button...
		if( (tempx > 300 && tempx < 300 + button_w) && (tempy > 500 && tempy < 500 + button_h) )
			{

				//draw the hover-ed version of play
				DrawIMG(play,300,500);
				
				//if they left click....
				if(SDL_GetMouseState(NULL, NULL)&SDL_BUTTON(1))
				{
					sound.Play(BUTTON_PUSH);
					//start the game!
					start = true;
			
				}
			} //else its not over the play button, so draw the non-hovered version of 'play'
				else DrawIMG(play2,300,500); 

		 SDL_Flip(data.screen);

	}//end of while ! resume

}//end of Messages::Options()

void Messages::Game_Over()
{
	sound.Stop_Music();
	sound.Play(MUS_GAMEOVER);
	bool play_again = false;		
	//draw our whole BG once... 
	DrawIMG(beatboard,0,0);

	//for getting the mouse coords as usual
	int tempx;
	int tempy;

	while(!play_again)
	{

		SDL_Event event;				//create an event holder

		  while ( SDL_PollEvent(&event) ) //looks for events
		 {
	  
			  if ( event.type == SDL_QUIT )  
			  {  
				  play_again = true;
				  data.done = 1;
			  } 

			  if ( event.type == SDL_KEYDOWN ) //if the user pressed a key then.....
			  {
				     if ( event.key.keysym.sym == SDLK_ESCAPE || event.key.keysym.sym == SDLK_q ) 
					 { 
						 play_again = true;
						 data.done = 1; //if they pressed escape or q then quit
					 } 
		
	    	   }//end of    if ( event.type == SDL_KEYDOWN ) 
   
		 }//end of   while ( SDL_PollEvent(&event) ) 

		 //draw PAUSED in big text in the middle of the screen
		 Draw_Txt("GAME OVER",250,250,BIG,LIGHT);
	  
		 
		 SDL_GetMouseState(&tempx, &tempy);    // Get the mouse coords

		  //if the users mouse is over the continue button...
	     if( (tempx > 300 && tempx < 300 + button_w) && (tempy > 500 && tempy < 500 + button_h) )
			{

				//draw the hover-ed version of play
				DrawIMG(cont2,300,500);
				
				//if they left click....
				if(SDL_GetMouseState(NULL, NULL)&SDL_BUTTON(1))
				{
					sound.Play(BUTTON_PUSH);
					//start the game!
					play_again = true;
		

				

				//set the ammo and score back to 0
				player.ammo = 0;
				player.score = 0;
				player.lives = 3;
				player.warps = 3;
	
				//set the enemies back into standby
				red_enemy.Set_State(ACTIVE,0,ACTIVE);   
			   	purple_enemy.Set_State(STANDBY,50,ACTIVE);
		    	blue_enemy.Set_State(STANDBY,100,ACTIVE);
				yellow_enemy.Set_State(STANDBY,150,ACTIVE);

	
				//our array of map names
				string Levels[5];

				Levels[0] = "level1.txt";
				Levels[1] = "level2.txt";
				Levels[2] = "level3.txt";
				Levels[3] = "level4.txt";
				Levels[4] = "level5.txt";

				//open the level we are on. 
				 Open(Levels[data.current_level - 1]);

				//re-set all the coordinates of the players/enemies/food/foodcount/etc.
				Init_Map();

				//start the timer for this level
				start_time = SDL_GetTicks(); 
			
				}
			
			} //else its not over the play button, so draw the non-hovered version of 'play'
				else DrawIMG(cont1,300,500); 

		 SDL_Flip(data.screen);

	}//end of while ! resume

	//stop our music on the way out and play our current boards music
	sound.Stop_Music();

	switch(data.current_level)
	{
	
		case 1:
		sound.Play(MUS_LEVEL1);
		break;

		case 2:
		sound.Play(MUS_LEVEL2);
		break;

		case 3:
		sound.Play(MUS_LEVEL3);
		break;

		case 4:
		sound.Play(MUS_LEVEL4);
		break;

		case 5:
		sound.Play(MUS_LEVEL5);
		break;
	}

	
}//end of game over

void Messages::You_Win()
{
	
	bool play_again = false;
	
	//flashing will switch up which color text we draw
	int flashing = 0;
	//every 20 frames draws the text 
    int every_20_frames = 0;
	sound.Stop_Music();
	//draw our whole BG once... 
	DrawIMG(beatboard,0,0);
	sound.Play(YOUWIN);
		
	while(!play_again)
	{

		SDL_Event event;				//create an event holder

		  while ( SDL_PollEvent(&event) ) //looks for events
		 {
	  
			  if ( event.type == SDL_QUIT )  
			  {  
				  play_again = true;
				  data.done = 1;
			  } 

			  if ( event.type == SDL_KEYDOWN ) //if the user pressed a key then.....
			  {
				     if ( event.key.keysym.sym == SDLK_ESCAPE || event.key.keysym.sym == SDLK_q ) 
					 { 
						 play_again = true;
						 data.done = 1; //if they pressed escape or q then quit
					 } 
		
	    	   }//end of    if ( event.type == SDL_KEYDOWN ) 
   
		 }//end of   while ( SDL_PollEvent(&event) ) 
		 
	if(every_20_frames % 20 == 0)
	 {

		 if(flashing == 0)
		 {
			 Draw_Txt("YOU WIN !!",rand()%800,rand()%600,BIG,LIGHT);
			 flashing++;
		 }
		 else if(flashing == 1)
		 {
			 Draw_Txt("YOU WIN !!",rand()%800,rand()%600,BIG,RED);
			 flashing++;
		 }
		 else if(flashing == 2)
		 {
			 Draw_Txt("YOU WIN !!",rand()%800,rand()%600,BIG,BLUE);
			 flashing = 0;
		 }
	 }

	      every_20_frames++;

		 SDL_Flip(data.screen);

	}//end of while ! resume

	
}//end of you win



