#ifndef MESSAGES_H
#define MESSAGES_H

#include "main.h"
#include "Audio.h"
#include "Entity.h"


enum Message
{
	BONUS,

	//colors for the Draw_Txt() function
	BLACK,
	LIGHT,
	BLUE,
	RED,

	//sizes for the Draw_Txt() function
    BIG,
	SMALL
};

class Messages
{
	public:
   
	Messages();
	~Messages();

	void Update_Message();							//update the current message being drawn
	void Set_Message(Message MESSAGE, int TIME);    //set the message to be drawn

	void Show_Intro();
	void Next_Level();
	void Options();
	void Game_Over();
	void You_Win();

	void Init();

	void Draw_Txt(char* message,int x,int y,Message SIZE,Message COLOR);

	void Pause();

   
	//bool quit;
    private:

	Message current_message; //what is the current message we are drawing?
	
	bool drawing_message; //are we currently drawing a message?
	
	int update_counter; //a counter used in update_message and set_ message()

	int button_w;
	int button_h;

	SDL_Surface *play;
	SDL_Surface *play2;
	SDL_Surface *introbg;
	SDL_Surface *introbgleft;
	SDL_Surface *introbgright;
	SDL_Surface *introbgpushed;

	SDL_Surface *controls1;
	SDL_Surface *controls2;
	SDL_Surface *beatboard;  //the blacktop looking bg
	SDL_Surface *bonus;								//the bonus image
    SDL_Surface *options; //the 800x600 options image
	SDL_Surface *cont1; //continue button
    SDL_Surface *cont2;

	//surface for text
	SDL_Surface* text;



	//font
	TTF_Font* font;
	TTF_Font* font_big;

};

#endif
