//SpriteBase.cpp
#include "SpriteBase.h"

//the destructor free's all the surfaces this spritebase holds
SpriteBase::~SpriteBase()
{
	    SDL_FreeSurface(North_Frame[0]);
		SDL_FreeSurface(North_Frame[1]);
		SDL_FreeSurface(North_Frame[2]);

		SDL_FreeSurface(South_Frame[0]);
		SDL_FreeSurface(South_Frame[1]);
		SDL_FreeSurface(South_Frame[2]);

		SDL_FreeSurface(East_Frame[0]);
		SDL_FreeSurface(East_Frame[1]);
		SDL_FreeSurface(East_Frame[2]);

		SDL_FreeSurface(West_Frame[0]);
		SDL_FreeSurface(West_Frame[1]);
		SDL_FreeSurface(West_Frame[2]);
}

void SpriteBase::Load_Frames(int ENTITY)
{
	//lets load in our frames depending on what entity we are talking about
	//its used like this : player_base.Load_Frames(PLAYER)

	switch (ENTITY)
	{
	
	case PLAYER:

		North_Frame[0] = Load_Image("images/player/N0.bmp");
		North_Frame[1] = Load_Image("images/player/N1.bmp");
		North_Frame[2] = Load_Image("images/player/N2.bmp");

		South_Frame[0] = Load_Image("images/player/S0.bmp");
		South_Frame[1] = Load_Image("images/player/S1.bmp");
		South_Frame[2] = Load_Image("images/player/S2.bmp");
		
		East_Frame[0] = Load_Image("images/player/E0.bmp");
		East_Frame[1] = Load_Image("images/player/E1.bmp");
		East_Frame[2] = Load_Image("images/player/E2.bmp");

		West_Frame[0] = Load_Image("images/player/W0.bmp");
		West_Frame[1] = Load_Image("images/player/W1.bmp");
		West_Frame[2] = Load_Image("images/player/W2.bmp");
	
		break;

	case RED_ENEMY:
		
		North_Frame[0] = Load_Image("images/red_enemy/NS0.bmp");
		North_Frame[1] = Load_Image("images/red_enemy/NS1.bmp");
		North_Frame[2] = Load_Image("images/red_enemy/NS2.bmp");

		//for the enemies south frames, we just copy the north ones
		//because they use the same image
		South_Frame[0] = SDL_DisplayFormat(North_Frame[0]);
		South_Frame[1] = SDL_DisplayFormat(North_Frame[1]);
		South_Frame[2] = SDL_DisplayFormat(North_Frame[2]);
		
		East_Frame[0] = Load_Image("images/red_enemy/E0.bmp");
		East_Frame[1] = Load_Image("images/red_enemy/E1.bmp");
		East_Frame[2] = Load_Image("images/red_enemy/E2.bmp");

		West_Frame[0] = Load_Image("images/red_enemy/W0.bmp");
		West_Frame[1] = Load_Image("images/red_enemy/W1.bmp");
		West_Frame[2] = Load_Image("images/red_enemy/W2.bmp");
	
		break;

	case PURPLE_ENEMY:
		
		North_Frame[0] = Load_Image("images/purple_enemy/NS0.bmp");
		North_Frame[1] = Load_Image("images/purple_enemy/NS1.bmp");
		North_Frame[2] = Load_Image("images/purple_enemy/NS2.bmp");

		South_Frame[0] = SDL_DisplayFormat(North_Frame[0]);
		South_Frame[1] = SDL_DisplayFormat(North_Frame[1]);
		South_Frame[2] = SDL_DisplayFormat(North_Frame[2]);

		East_Frame[0] = Load_Image("images/purple_enemy/E0.bmp");
		East_Frame[1] = Load_Image("images/purple_enemy/E1.bmp");
		East_Frame[2] = Load_Image("images/purple_enemy/E2.bmp");

		West_Frame[0] = Load_Image("images/purple_enemy/W0.bmp");
		West_Frame[1] = Load_Image("images/purple_enemy/W1.bmp");
		West_Frame[2] = Load_Image("images/purple_enemy/W2.bmp");

		break;

	case BLUE_ENEMY:

		North_Frame[0] = Load_Image("images/blue_enemy/NS0.bmp");
		North_Frame[1] = Load_Image("images/blue_enemy/NS1.bmp");
		North_Frame[2] = Load_Image("images/blue_enemy/NS2.bmp");

		South_Frame[0] = SDL_DisplayFormat(North_Frame[0]);
		South_Frame[1] = SDL_DisplayFormat(North_Frame[1]);
		South_Frame[2] = SDL_DisplayFormat(North_Frame[2]);
		
		East_Frame[0] = Load_Image("images/blue_enemy/E0.bmp");
		East_Frame[1] = Load_Image("images/blue_enemy/E1.bmp");
		East_Frame[2] = Load_Image("images/blue_enemy/E2.bmp");

		West_Frame[0] = Load_Image("images/blue_enemy/W0.bmp");
		West_Frame[1] = Load_Image("images/blue_enemy/W1.bmp");
		West_Frame[2] = Load_Image("images/blue_enemy/W2.bmp");
		
		break;

	case YELLOW_ENEMY:

		North_Frame[0] = Load_Image("images/yellow_enemy/NS0.bmp");
		North_Frame[1] = Load_Image("images/yellow_enemy/NS1.bmp");
		North_Frame[2] = Load_Image("images/yellow_enemy/NS2.bmp");

		South_Frame[0] = SDL_DisplayFormat(North_Frame[0]);
		South_Frame[1] = SDL_DisplayFormat(North_Frame[1]);
		South_Frame[2] = SDL_DisplayFormat(North_Frame[2]);
		
		East_Frame[0] = Load_Image("images/yellow_enemy/E0.bmp");
		East_Frame[1] = Load_Image("images/yellow_enemy/E1.bmp");
		East_Frame[2] = Load_Image("images/yellow_enemy/E2.bmp");

		West_Frame[0] = Load_Image("images/yellow_enemy/W0.bmp");
		West_Frame[1] = Load_Image("images/yellow_enemy/W1.bmp");
		West_Frame[2] = Load_Image("images/yellow_enemy/W2.bmp");

		break;

	case GREY:

		North_Frame[0] = Load_Image("images/scared_grey/NS0.bmp");
		North_Frame[1] = Load_Image("images/scared_grey/NS1.bmp");
		North_Frame[2] = Load_Image("images/scared_grey/NS2.bmp");

		South_Frame[0] = SDL_DisplayFormat(North_Frame[0]);
		South_Frame[1] = SDL_DisplayFormat(North_Frame[1]);
		South_Frame[2] = SDL_DisplayFormat(North_Frame[2]);
		
		East_Frame[0] = Load_Image("images/scared_grey/E0.bmp");
		East_Frame[1] = Load_Image("images/scared_grey/E1.bmp");
		East_Frame[2] = Load_Image("images/scared_grey/E2.bmp");

		West_Frame[0] = Load_Image("images/scared_grey/W0.bmp");
		West_Frame[1] = Load_Image("images/scared_grey/W1.bmp");
		West_Frame[2] = Load_Image("images/scared_grey/W2.bmp");

		break;

		case WHITE:

		North_Frame[0] = Load_Image("images/scared_white/NS0.bmp");
		North_Frame[1] = Load_Image("images/scared_white/NS1.bmp");
		North_Frame[2] = Load_Image("images/scared_white/NS2.bmp");

		South_Frame[0] = SDL_DisplayFormat(North_Frame[0]);
		South_Frame[1] = SDL_DisplayFormat(North_Frame[1]);
		South_Frame[2] = SDL_DisplayFormat(North_Frame[2]);
		
		East_Frame[0] = Load_Image("images/scared_white/E0.bmp");
		East_Frame[1] = Load_Image("images/scared_white/E1.bmp");
		East_Frame[2] = Load_Image("images/scared_white/E2.bmp");

		West_Frame[0] = Load_Image("images/scared_white/W0.bmp");
		West_Frame[1] = Load_Image("images/scared_white/W1.bmp");
		West_Frame[2] = Load_Image("images/scared_white/W2.bmp");

		break;

	}//end of switch ENTITY


  //now we just make all of the freshly loaded frames treat magenta as transparent
  
  SDL_SetColorKey(North_Frame[0], SDL_SRCCOLORKEY,SDL_MapRGB(North_Frame[0]->format, 255, 0, 255));
  SDL_SetColorKey(North_Frame[1], SDL_SRCCOLORKEY,SDL_MapRGB(North_Frame[1]->format, 255, 0, 255));
  SDL_SetColorKey(North_Frame[2], SDL_SRCCOLORKEY,SDL_MapRGB(North_Frame[2]->format, 255, 0, 255));
  
  SDL_SetColorKey(South_Frame[0], SDL_SRCCOLORKEY,SDL_MapRGB(South_Frame[0]->format, 255, 0, 255));
  SDL_SetColorKey(South_Frame[1], SDL_SRCCOLORKEY,SDL_MapRGB(South_Frame[1]->format, 255, 0, 255));
  SDL_SetColorKey(South_Frame[2], SDL_SRCCOLORKEY,SDL_MapRGB(South_Frame[2]->format, 255, 0, 255));
  
  
  SDL_SetColorKey(East_Frame[0], SDL_SRCCOLORKEY,SDL_MapRGB(East_Frame[0]->format, 255, 0, 255));
  SDL_SetColorKey(East_Frame[1], SDL_SRCCOLORKEY,SDL_MapRGB(East_Frame[1]->format, 255, 0, 255));
  SDL_SetColorKey(East_Frame[2], SDL_SRCCOLORKEY,SDL_MapRGB(East_Frame[2]->format, 255, 0, 255));
  
  SDL_SetColorKey(West_Frame[0], SDL_SRCCOLORKEY,SDL_MapRGB(West_Frame[0]->format, 255, 0, 255));
  SDL_SetColorKey(West_Frame[1], SDL_SRCCOLORKEY,SDL_MapRGB(West_Frame[1]->format, 255, 0, 255));
  SDL_SetColorKey(West_Frame[2], SDL_SRCCOLORKEY,SDL_MapRGB(West_Frame[2]->format, 255, 0, 255));
  
}//end of Init()

